import { actionPromise } from "."
import { actionGoodById } from "./index";
import gql from "../api"

const actionChangeArrInGood = (_id, arr) => 
  async (dispatch) => {
    await dispatch(actionPromise('changeArrInGood', gql(`mutation changeArrImgInGood ($good:GoodInput){
      GoodUpsert(good:$good){
        _id name
      }
    }`, {
      "good": {
        "_id": _id,
        "images": arr,
      }
    })));

    dispatch(actionGoodById(_id));
  }

export default actionChangeArrInGood; 