import { useEffect } from "react";
import { connect } from "react-redux";
import { actionCatById } from "../action";
import { NameCategory, AddCategory, CartChangeGood, CNewGoodInCat } from "../components";
import { CPromisePreloader } from '../reducer';

 
const PCategoryAdmin = ({match, match: {params: {_id}}, getData}) => { console.log('match', match)
  useEffect( () => {
    getData(_id);
  }, [_id]);                            console.log('======id', _id)

  return (
    <> 
      <CPromisePreloader name={'catById'}>
        {/* Изменить категорию товара */}
        <div>
          <NameCategory _id={_id}/>
        </div>
          {/* Добавть категорию товара */}
        <div>
          <AddCategory/>
        </div>
          {/* Добавить товар в категорию */}
        <div>
          <CNewGoodInCat/>
        </div>  
        {/* Изменить товар */}
        <div>
          <CartChangeGood _idCat={_id}/>
        </div>
      </CPromisePreloader>
    </> 
  )
}



const PageCategoryAdmin = connect(null, {getData: actionCatById})(PCategoryAdmin)

export default PageCategoryAdmin;