import { Layout, Menu, Breadcrumb, Row, Col, Avatar  } from 'antd';
import { UserOutlined, LaptopOutlined, NotificationOutlined, createFromIconfontCN  } from '@ant-design/icons';
import '../App.css';
import 'antd/dist/antd.min.css';
import {Router, Route, Link, Redirect, Switch} from 'react-router-dom';
import { actionRootCats } from "../action";



import {SignIn, ListOrders, Page404} from '../components';
import { CCategoryList, SwitchRoute } from '../components';
import { useEffect } from 'react';
import CPageCategory from './cpageCategory';
import CreatePageGood from './pageGood';
import { HeaderSite } from '../components';
import PageBasket from './pageBasket';
import { RegisterIn } from '../components';
import { UseRoute, RouteSite } from '../route'


const { SubMenu } = Menu;
const { Header, Content, Footer, Sider } = Layout;
const IconFont = createFromIconfontCN({
  scriptUrl: '//at.alicdn.com/t/font_8d5l8fzk5b87iudi.js',
});

function PageUser () {

  return (
    <Layout>
     <HeaderSite/>
    <Content style={{ padding: '0 50px' }}>
      <Breadcrumb style={{ margin: '16px 0' }}/>
      <Layout className="site-layout-background" style={{ marginTop: '-2px 0' }}>
        <Sider className="site-layout-background" width={230}>
          <Menu
            mode="inline"
            defaultSelectedKeys={['1']}
            defaultOpenKeys={['sub1']}
            style={{ height: '100%' }}
          >
            <CCategoryList/>
          </Menu>
        </Sider>
        <Content style={{ padding: '0 24px', minHeight: 280 }}>Content
          <Switch>
            <RouteSite/>
          </Switch>
        </Content>  
      </Layout>
    </Content>
    <Footer style={{ textAlign: 'center' }}>Ant Design ©2018 Created by Ant UED</Footer>
  </Layout>
  )
  
}

export default PageUser;