import {Router, Route, Link, Redirect, Switch} from 'react-router-dom';
import { SignIn, RegisterIn, ListOrders, EmptyContent, Page404} from '../components';
import { PageBasket, CPageCategory, CreatePageGood, PageSearch}  from '../pages';




const UseRoute = () => {
  return (
    <>
      {/* <Redirect from="/main" to='/' /> */}
      <Route path="/" component={EmptyContent} exact />
      <Route path = "/login" component = {SignIn}/>
      <Route path = "/registration" component = {RegisterIn} />
      <Route path = "/category/:_id" component = {CPageCategory}/>
      <Route path = "/good/:_id" component = {CreatePageGood}/>
      <Route path = "/basket" component={PageBasket}/> 
      <Route path = "/listOrders" component={ListOrders}/>
      <Route path = "/search/:value" component = {PageSearch}/>
      {/* <Route path = "*" component={Page404}/> */}
    </>
  )
}

export default UseRoute;